//+------------------------------------------------------------------+
//|                                                     Trigger Line |
//|                             Copyright  2005 dwt5 and adoleh2000 |
//|mtf 2008forexTSD.com ml  ki             http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005 dwt5 and adoleh2000 "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4            
#property indicator_color1 Red      
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//int width;

extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern int             Rperiod     = 15;
extern int             LSMA_Period = 5;
extern int             Shift_      = 0;

int Draw4HowLong;
int shift;
int j;
int loopbegin;
int length;
int lsma_length;

double lengthvar;
double tmp ;
double tmp2 ;
double wt[];
double sum[];
double lsma_sum[];
double lsma_ma[];
double middle[];
int c;
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 7 additional buffers are used for counting.
   IndicatorBuffers(7);   
   
//---- drawing settings
   
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == -99;
      TimeFrame         = MathMax(TimeFrame,_Period);
//
   SetIndexShift(0,Shift_*TimeFrame/Period());
   SetIndexShift(1,Shift_*TimeFrame/Period());
   SetIndexShift(2,Shift_*TimeFrame/Period());
   SetIndexShift(3,Shift_*TimeFrame/Period());
   
   SetIndexLabel(1,"TL("+Rperiod+"|"+LSMA_Period+")["+TimeFrame+"]");
   SetIndexLabel(2,"TL("+Rperiod+"|"+LSMA_Period+")["+TimeFrame+"]");
  
   SetIndexBuffer(4,sum);        
   SetIndexBuffer(5,wt);         
   SetIndexBuffer(6,lsma_ma);

    
    IndicatorShortName("TriggL ("+Rperiod+"|"+LSMA_Period+")["+TimeFrame+"] ");  
   return(0);
  }

int start()
  {  
   int i,y,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
   if (TimeFrame != Period())
      {
         limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i=limit; i>=0; i--)
           {
               y = iBarShift(NULL,TimeFrame,Time[i]);
               ExtMapBuffer1 [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rperiod,LSMA_Period,0,0,y);         
               ExtMapBuffer2 [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rperiod,LSMA_Period,0,1,y);         
               ExtMapBuffer3 [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rperiod,LSMA_Period,0,2,y);         
               ExtMapBuffer4 [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Rperiod,LSMA_Period,0,3,y);         
            }
         return(0);         
      }
  
      Draw4HowLong = Bars-Rperiod - 5;                            //Rperiod = 20
      length = Rperiod;                                           //length now = 20  
      lsma_length = LSMA_Period;
      loopbegin = Draw4HowLong - length - 1;   
      

      for(shift = loopbegin; shift >= 0; shift--)  //  MAIN For Loop
      { 
         sum[1] = 0;                                              
         for(i = length; i >= 1  ; i--)             //LSMA loop
         {
         lengthvar = length + 1;                               //lengthvar = 21  
         lengthvar /= 3;                                       //lengthvar = 7
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];         //tmp = 20 - 7 * close[20-i+shift]
         sum[1]+=tmp;
         }
         wt[shift] = sum[1]*6/(length*(length+1));  
         j = shift;
         lsma_ma[shift] = wt[j+1] + (wt[j]-wt[j+1])* 2/(lsma_length+1);
  
                          
//========== COLOR CODING ===========================================                       
        
        
            ExtMapBuffer1[shift] = wt[shift]; 
            ExtMapBuffer2[shift] = lsma_ma[shift]; 
            ExtMapBuffer3[shift] = wt[shift]; 
            ExtMapBuffer4[shift] = lsma_ma[shift]; 
            
            
            
            if (wt[shift]  < lsma_ma[shift])
            {
                ExtMapBuffer4[shift] = EMPTY_VALUE;
                ExtMapBuffer3[shift] = EMPTY_VALUE;
           }          
        
        }
        return(0);
  }
//+------------------------------------------------------------------+



